ChangeSet 1.1608.24.29, 2004/03/01 13:55:09-08:00, brill@fs.math.uni-frankfurt.de

[PATCH] USB Storage: unusual_devs.h entry submission

here is an unusual_devs.h entry which makes two different USB MP3 players
work with Linux' USB storage driver. They share a core chip, the t33520 USB
flash card controller by Trumpion microelectronics. They also share the same
ID 0x090a:0x1001, which is a "generic" ID for t33520 devices using bulk-only
protocol (0x1002 is for CB).

About the MP3 players:
  - I own an apparently unbranded one (sold in masses on ebay.de) which
    needs US_FL_MODE_XLATE (and used to need US_FL_START_STOP before its
    removal).
  - Theodore Kilgore (who created the 0x090a:0x1001 record in the
    Linux-USB device overwiew) has a "Trumpion Digital Research MYMP3"
    which needs US_FL_MODE_XLATE and an explicit US_PR_BULK.
Of course the different players report the same firmware rev. 1.00,
despite their obviously different behaviour. Ugh.

There are more players with this ID, the "Kaser Yofun 100 MP-3" (also
rev. 1.00) being one. The proposed entry may or may not help them, but
it shouldn't break working ones in any case. It is not unlikely they too
will need US_FL_MODE_XLATE.

Below you'll find my /proc/bus/usb/devices with mounted MP3 player and a
patch against 2.4.25-rc3. Please apply.



 ----------------8<-------------------------8<--------------------

T:  Bus=01 Lev=00 Prnt=00 Port=00 Cnt=00 Dev#=  1 Spd=12  MxCh= 2
B:  Alloc=  0/900 us ( 0%), #Int=  0, #Iso=  0
D:  Ver= 1.00 Cls=09(hub  ) Sub=00 Prot=00 MxPS= 8 #Cfgs=  1
P:  Vendor=0000 ProdID=0000 Rev= 0.00
S:  Product=USB UHCI Root Hub
S:  SerialNumber=e400
C:* #Ifs= 1 Cfg#= 1 Atr=40 MxPwr=  0mA
I:  If#= 0 Alt= 0 #EPs= 1 Cls=09(hub  ) Sub=00 Prot=00 Driver=hub
E:  Ad=81(I) Atr=03(Int.) MxPS=   8 Ivl=255ms
T:  Bus=01 Lev=01 Prnt=01 Port=01 Cnt=01 Dev#=  2 Spd=12  MxCh= 0
D:  Ver= 1.10 Cls=00(>ifc ) Sub=00 Prot=00 MxPS= 8 #Cfgs=  1
P:  Vendor=090a ProdID=1001 Rev= 1.00
C:* #Ifs= 1 Cfg#= 1 Atr=80 MxPwr= 60mA
I:  If#= 0 Alt= 0 #EPs= 3 Cls=08(stor.) Sub=06 Prot=50 Driver=usb-storage
E:  Ad=81(I) Atr=02(Bulk) MxPS=  64 Ivl=0ms
E:  Ad=02(O) Atr=02(Bulk) MxPS=  64 Ivl=0ms
E:  Ad=83(I) Atr=03(Int.) MxPS=   8 Ivl=255ms

 ----------------8<-------------------------8<--------------------


 drivers/usb/storage/unusual_devs.h |   11 +++++++++++
 1 files changed, 11 insertions(+)


diff -Nru a/drivers/usb/storage/unusual_devs.h b/drivers/usb/storage/unusual_devs.h
--- a/drivers/usb/storage/unusual_devs.h	Tue Mar 16 15:05:08 2004
+++ b/drivers/usb/storage/unusual_devs.h	Tue Mar 16 15:05:08 2004
@@ -654,6 +654,17 @@
 		US_SC_DEVICE, US_PR_DEVICE, NULL,
 		US_FL_MODE_XLATE ),
 
+/* Entry needed for flags. Moreover, all devices with this ID use
+ * bulk-only transport, but _some_ falsely report Control/Bulk instead.
+ * One example is "Trumpion Digital Research MYMP3".
+ * Submitted by Bjoern Brill <brill(at)fs.math.uni-frankfurt.de>
+ */
+UNUSUAL_DEV(  0x090a, 0x1001, 0x0100, 0x0100,
+		"Trumpion",
+		"t33520 USB Flash Card Controller",
+		US_SC_DEVICE, US_PR_BULK, NULL,
+		US_FL_MODE_XLATE),
+
 /* Trumpion Microelectronics MP3 player (felipe_alfaro@linuxmail.org) */
 UNUSUAL_DEV( 0x090a, 0x1200, 0x0000, 0x9999,
 		"Trumpion",
